global
  presetenv API_WS_PORT "${API_PORT}" #Default api websocket port
  maxconn 4096
  log stdout format raw local0 info

defaults
  log global
  option httplog
  mode http
  balance roundrobin
  option redispatch
  option forwardfor
  timeout connect 5s
  timeout queue 5s
  timeout client 50s
  timeout server 50s

# [Reverse-proxy frontend]
frontend http-in
  bind "*:${REVPROXY_PORT}"
  
  default_backend front_app
  acl is_websocket_api path_beg "/${API_WS_NAME}"
  acl is_classic_api path_beg "/${API_NAME}"

  use_backend api_websocket if is_websocket_api
  use_backend api_web if is_classic_api


# [Reverse-proxy backend] api-rest
backend api_web
  server api-server "${API_HOSTNAME}:${API_PORT}" weight 1 maxconn 1024 check
  http-request add-header X-Forwarded-Proto https if { ssl_fc }
  option forwardfor except 127.0.0.1

# [Reverse-proxy backend] websocket
backend api_websocket
  balance roundrobin
  option forwardfor except 127.0.0.1
  timeout tunnel 1h #IMPORTANT: C'est le temps d'inactivité autorisé avant deconnexion automatique.
  timeout connect 10s
  server ws-api-server "${API_WS_HOSTNAME}:${API_WS_PORT}" weight 1 maxconn 1024 check

# [Reverse-proxy backend] Frontend UI server
backend front_app
  option forwardfor except 127.0.0.1
  http-request add-header X-Forwarded-Proto https if { ssl_fc }
  server front-server "${FRONT_HOSTNAME}:${FRONT_PORT}" weight 1 maxconn 1024 check
